# Midi23D

## Summary

**Midi23D** is a tool made in Java that converts every note of a .midi music into GCODE instructions to send directly to a 3D printer.

![gui](/assets/midi23d/midi-gui.png)

## How it works

Every 3D printer has 3 or more particular motors, called **stepper motors**. Despite of the regular DC motors their angular speed and rotation be controlled very precisely.

Sending an impulse to that motors, in addition to result in a rotation, it will produce a sound, that it can be modulated by changing it.

With the GCODE you can tell to the 3D printer extruder to go in a position with a determined speed.

Setting the right speed for each motor by sending to the printer only the position and the total speed seems difficult, but it's quite easy.  
You must use this formula:

![explanation](/assets/midi23d/delta.svg)

In this way you can control simultaneously one note for each motor.

## Usage

First of all, download **_Midi23D.jar_**

[Midi23D.jar](http://gdb.altervista.org/downloads/Midi23D.jar)

Run the program by clicking on it if you have a GUI, or by executing it into your terminal:  
`java -jar Midi23D.jar <input-file.mid> <output-file.gcode> <speed-multiplier> <tone-multiplier> <motor-test>`  
_(Motor-test is a boolean (true/false) parameter that if it's true it plays the same notes on all the motors. It helps when you try to accord each motor speed)._

Insert the parameters that asks to you.

Drag and drop the generated file into Repetier Host or your program that controls your printer.

Enjoy

## Samples

* [Pokémon center.mid](http://gdb.altervista.org/downloads/midi/pokemon_center.mid)
* [Pokémon Red route 1.mid](http://gdb.altervista.org/downloads/midi/route_1.mid)
* [Pokémon Red route 24.mid](http://gdb.altervista.org/downloads/midi/route_24.mid)
* [Harry Potter theme.mid](http://gdb.altervista.org/downloads/midi/HarryPotter.mid)
* [Super Mario Bros theme.mid](http://gdb.altervista.org/downloads/midi/super_mario_bros.mid)
* [Castlevania Legends Boss.mid](http://gdb.altervista.org/downloads/midi/CVL_Boss.mid)
* [Harry Potter for gameboy Main menu.mid](http://gdb.altervista.org/downloads/midi/Harry_Potter_game_main_menu.mid)
* [Wild Pokémon encounter.mid](http://gdb.altervista.org/downloads/midi/wild_pokemon_battle.mid)

## Videos

<div style="margin: auto; text-align: center;">
<iframe width="560" height="315" src="https://www.youtube.com/embed/4rcnu8j1Xqk" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen style="max-width: 100%;"></iframe>
</div>